generic: new case to test getcwd(2)
[xfstests-dev.git] / check
diff --git a/check b/check
index 966fbe556b6a6225c38ee3c2619e54034a501000..b1eaed2620d0d993096611a07c2b61edfd183874 100755 (executable)
--- a/check
+++ b/check
 tmp=/tmp/$$
 status=0
 needwrap=true
+needsum=true
 n_try=0
 try=""
 n_bad=0
+sum_bad=0
 bad=""
 notrun=""
 interrupt=true
@@ -32,8 +34,7 @@ diff="diff -u"
 showme=false
 have_test_arg=false
 randomize=false
-here=`pwd`
-FSTYP=xfs
+export here=`pwd`
 xfile=""
 
 # start the initialisation work now
@@ -57,36 +58,30 @@ then
     exit 1
 fi
 
-# Autodetect fs type based on what's on $TEST_DEV
-if [ "$HOSTOS" == "Linux" ]; then
-    FSTYP=`blkid -c /dev/null -s TYPE -o value $TEST_DEV`
-fi
-export FSTYP
-
 SUPPORTED_TESTS="[0-9][0-9][0-9] [0-9][0-9][0-9][0-9]"
 SRC_GROUPS="generic shared"
 export SRC_DIR="tests"
-export RESULT_BASE=${RESULT_BASE:="$here/results"}
 
 usage()
 {
     echo "Usage: $0 [options] [testlist]"'
 
 check options
-    -xfs                test XFS (default)
-    -udf                test UDF
     -nfs                test NFS
+    -tmpfs              test TMPFS
     -l                 line mode diff
     -udiff             show unified diff (default)
     -n                 show me, do not run tests
     -T                 output timestamps
     -r                 randomize test order
     --large-fs         optimise scratch device for large filesystems
+    -s section         run only specified section from config file
 
 testlist options
     -g group[,group...]        include tests from these groups
     -x group[,group...]        exclude tests from these groups
     -X file            exclude individual tests
+    -E external_file   exclude individual tests
     [testlist]         include tests matching names in testlist
 '
            exit 0
@@ -115,7 +110,7 @@ get_all_tests()
        for d in $SRC_GROUPS $FSTYP; do
                ls $SRC_DIR/$d/* | \
                        grep -v "\..*" | \
-                       grep -v group >> $tmp.list 2>/dev/null
+                       grep -v "group\|Makefile" >> $tmp.list 2>/dev/null
        done
 }
 
@@ -145,7 +140,7 @@ trim_test_list()
 
 _wallclock()
 {
-    date "+%H %M %S" | $AWK_PROG '{ print $1*3600 + $2*60 + $3 }'
+    date "+%s"
 }
 
 _timestamp()
@@ -154,45 +149,70 @@ _timestamp()
     echo -n " [$now]"
 }
 
-# Process command arguments first.
-while [ $# -gt 0 ]; do
-       case "$1" in
-       -\? | -h | --help) usage ;;
-
-       -udf)   FSTYP=udf ;;
-       -xfs)   FSTYP=xfs ;;
-       -nfs)   FSTYP=nfs ;;
+_prepare_test_list()
+{
+       unset list
+       # Tests specified on the command line
+       if [ -s $tmp.arglist ]; then
+               cat $tmp.arglist > $tmp.list
+       else
+               touch $tmp.list
+       fi
 
-       -g)     group=$2 ; shift ;
-               group_list=$(get_group_list $group)
-               if [ -z "$group_list" ]; then
-                   echo "Group \"$group\" is empty or not defined?"
-                   exit 1
+       # Specified groups to include
+       for group in $GROUP_LIST; do
+               list=$(get_group_list $group)
+               if [ -z "$list" ]; then
+                       echo "Group \"$group\" is empty or not defined?"
+                       exit 1
                fi
 
-               [ ! -s $tmp.list ] && touch $tmp.list
-               for t in $group_list; do
+               for t in $list; do
                        grep -s "^$t\$" $tmp.list >/dev/null || \
                                                        echo "$t" >>$tmp.list
                done
+       done
 
-               ;;
+       if ! $have_test_arg && [ -z "$GROUP_LIST" ]; then
+               # no test numbers, do everything
+               get_all_tests
+       fi
 
-       -x)     xgroup=$2 ; shift ;
+       # Specified groups to exclude
+       for xgroup in $XGROUP_LIST; do
+               list=$(get_group_list $xgroup)
+               if [ -z "$list" ]; then
+                       echo "Group \"$xgroup\" is empty or not defined?"
+                       exit 1
+               fi
 
-               # Note: behaviour is dependent on command line ordering of
-               # -g and -x parameters. If there are no preceding -g commands,
-               # this works on all tests, otherwise just the tests specified by
-               # the early -g inclusions.
-               [ ! -s $tmp.list ] && get_all_tests
+               trim_test_list $list
+       done
 
-               group_list=$(get_group_list $xgroup)
-               if [ -z "$group_list" ]; then
-                   echo "Group \"$xgroup\" is empty or not defined?"
-                   exit 1
-               fi
+       # sort the list of tests into numeric order
+       list=`sort -n $tmp.list | uniq`
+       rm -f $tmp.list $tmp.tmp $tmp.grep
+
+       if $randomize
+       then
+               list=`echo $list | awk -f randomize.awk`
+       fi
+}
+
+# Process command arguments first.
+while [ $# -gt 0 ]; do
+       case "$1" in
+       -\? | -h | --help) usage ;;
+
+       -nfs)   FSTYP=nfs ;;
+       -tmpfs) FSTYP=tmpfs ;;
 
-               trim_test_list $group_list
+       -g)     group=$2 ; shift ;
+               GROUP_LIST="$GROUP_LIST $group"
+               ;;
+
+       -x)     xgroup=$2 ; shift ;
+               XGROUP_LIST="$XGROUP_LIST $xgroup"
                ;;
 
        -X)     xfile=$2; shift ;
@@ -203,7 +223,12 @@ while [ $# -gt 0 ]; do
                        done
                done
                ;;
-
+       -E)     xfile=$2; shift ;
+               if [ -f $xfile ]; then
+                       cat "$xfile" >> $tmp.xlist
+               fi
+               ;;
+       -s)     RUN_SECTION="$RUN_SECTION $2"; shift ;;
        -l)     diff="diff" ;;
        -udiff) diff="$diff -u" ;;
 
@@ -239,12 +264,13 @@ if $have_test_arg; then
                        exit $status
                        ;;
                *)      test_dir=`dirname $1`
+                       test_dir=${test_dir#$SRC_DIR/*}
                        test_name=`basename $1`
                        group_file=$SRC_DIR/$test_dir/group
 
-                       if grep "^$testname" $group_file >/dev/null ; then
+                       if egrep "^$test_name" $group_file >/dev/null ; then
                                # in group file ... OK
-                               echo $SRC_DIR/$1 >>$tmp.list
+                               echo $SRC_DIR/$test_dir/$test_name >>$tmp.arglist
                        else
                                # oops
                                echo "$1 - unknown test, ignored"
@@ -256,26 +282,6 @@ if $have_test_arg; then
        done
 fi
 
-if [ -s $tmp.list ]; then
-    # found some valid test numbers ... this is good
-    :
-elif $have_test_arg; then
-       # had test numbers, but none in group file ... do nothing
-       touch $tmp.list
-else
-       # no test numbers, do everything from group file
-       sed -n -e '/^[0-9][0-9][0-9]*/s/[       ].*//p' <group >$tmp.list
-fi
-
-# sort the list of tests into numeric order
-list=`sort -n $tmp.list`
-rm -f $tmp.list $tmp.tmp $tmp.grep
-
-if $randomize
-then
-    list=`echo $list | awk -f randomize.awk`
-fi
-
 # we need common/rc
 if ! . ./common/rc
 then
@@ -289,18 +295,26 @@ then
     exit 1
 fi
 
-# Ok, time to start running...
+_wipe_counters()
+{
+       n_try="0"
+       n_bad="0"
+       unset try notrun bad
+}
 
 _wrapup()
 {
+    seq="check"
+    check="$RESULT_BASE/check"
+
     if $showme
     then
        :
     elif $needwrap
     then
-       if [ -f check.time -a -f $tmp.time ]
+       if [ -f $check.time -a -f $tmp.time ]
        then
-           cat check.time $tmp.time \
+           cat $check.time $tmp.time \
            | $AWK_PROG '
        { t[$1] = $2 }
 END    { if (NR > 0) {
@@ -308,222 +322,321 @@ END     { if (NR > 0) {
          }
        }' \
            | sort -n >$tmp.out
-           mv $tmp.out check.time
+           mv $tmp.out $check.time
        fi
 
-       echo "" >>check.log
-       date >>check.log
-       echo $list | fmt | sed -e 's/^/    /' -e "s;$SRC_DIR/;;g" >>check.log
-       $interrupt && echo "Interrupted!" >>check.log
-        
+       echo "" >>$check.log
+       date >>$check.log
+       echo $list | fmt | sed -e 's/^/    /' -e "s;$SRC_DIR/;;g" >>$check.log
+       $interrupt && echo "Interrupted!" >>$check.log
+
+       echo "SECTION       -- $section" >>$tmp.summary
+       echo "=========================" >>$tmp.summary
         if [ ! -z "$n_try" -a $n_try != 0 ]
        then
            echo "Ran:$try"
+           echo "Ran:$try" >>$tmp.summary
        fi
 
        if [ ! -z "$notrun" ]
        then
            echo "Not run:$notrun"
-           echo "Not run:$notrun" >>check.log
+           echo "Not run:$notrun" >>$check.log
+           echo "Not run:$notrun" >>$tmp.summary
        fi
 
         if [ ! -z "$n_bad" -a $n_bad != 0 ]
        then
            echo "Failures:$bad"
            echo "Failed $n_bad of $n_try tests"
-           echo "Failures:$bad" | fmt >>check.log
-           echo "Failed $n_bad of $n_try tests" >>check.log
+           echo "Failures:$bad" | fmt >>$check.log
+           echo "Failed $n_bad of $n_try tests" >>$check.log
+           echo "Failures:$bad" >>$tmp.summary
+           echo "Failed $n_bad of $n_try tests" >>$tmp.summary
        else
            echo "Passed all $n_try tests"
-           echo "Passed all $n_try tests" >>check.log
+           echo "Passed all $n_try tests" >>$check.log
+           echo "Passed all $n_try tests" >>$tmp.summary
        fi
+       echo "" >>$tmp.summary
        needwrap=false
     fi
 
+    sum_bad=`expr $sum_bad + $n_bad`
+    _wipe_counters
     rm -f /tmp/*.rawout /tmp/*.out /tmp/*.err /tmp/*.time
-    rm -f $tmp.*
+    if ! $OPTIONS_HAVE_SECTIONS; then
+        rm -f $tmp.*
+    fi
 }
 
-trap "_wrapup; exit \$status" 0 1 2 3 15
-
-# don't leave old full output behind on a clean run
-rm -f check.full
+_summary()
+{
+       _wrapup
+       if $showme; then
+               :
+       elif $needsum; then
+               count=`wc -L $tmp.summary | cut -f1 -d" "`
+               cat $tmp.summary
+               needsum=false
+       fi
+       rm -f $tmp.*
+}
 
-[ -f check.time ] || touch check.time
+_prepare_test_list
 
-# print out our test configuration
-echo "FSTYP         -- `_full_fstyp_details`"
-echo "PLATFORM      -- `_full_platform_details`"
-if [ ! -z "$SCRATCH_DEV" ]; then
-  echo "MKFS_OPTIONS  -- `_scratch_mkfs_options`"
-  echo "MOUNT_OPTIONS -- `_scratch_mount_options`"
-fi
-echo
-
-
-if [ ! -z "$SCRATCH_DEV" ]; then
-  umount $SCRATCH_DEV 2>/dev/null
-  # call the overridden mkfs - make sure the FS is built
-  # the same as we'll create it later.
-
-  if ! _scratch_mkfs $flag >$tmp.err 2>&1
-  then
-      echo "our local _scratch_mkfs routine ..."
-      cat $tmp.err
-      echo "check: failed to mkfs \$SCRATCH_DEV using specified options"
-      exit 1
-  fi
-
-  # call the overridden mount - make sure the FS mounts with
-  # the same options that we'll mount with later.
-  if ! _scratch_mount >$tmp.err 2>&1
-  then
-      echo "our local mount routine ..."
-      cat $tmp.err
-      echo "check: failed to mount \$SCRATCH_DEV using specified options"
-      exit 1
-  fi
+if $OPTIONS_HAVE_SECTIONS; then
+       trap "_summary; exit \$status" 0 1 2 3 15
+else
+       trap "_wrapup; exit \$status" 0 1 2 3 15
 fi
 
-mkdir -p $RESULT_BASE
-if [ ! -d $RESULT_BASE ]; then
-       echo "failed to create results directory $RESULTS_BASE"
-       exit 1;
-fi
+for section in $HOST_OPTIONS_SECTIONS; do
+       OLD_FSTYP=$FSTYP
+       OLD_MOUNT_OPTIONS=$MOUNT_OPTIONS
+       get_next_config $section
+
+       # Do we need to run only some sections ?
+       if [ ! -z "$RUN_SECTION" ]; then
+               skip=true
+               for s in $RUN_SECTION; do
+                       if [ $section == $s ]; then
+                               skip=false
+                       fi
+               done
+               if $skip; then
+                       continue
+               fi
+       fi
 
-seq="check"
-_check_test_fs
+       mkdir -p $RESULT_BASE
+       if [ ! -d $RESULT_BASE ]; then
+               echo "failed to create results directory $RESULT_BASE"
+               exit 1;
+       fi
 
-for seq in $list
-do
-    err=false
+       if $OPTIONS_HAVE_SECTIONS; then
+               echo "SECTION       -- $section"
+       fi
 
-    # the filename for the test and the name output are different.
-    # we don't include the tests/ directory in the name output.
-    seqnum=`echo $seq | sed -e "s;$SRC_DIR/;;"`
+       if $RECREATE_TEST_DEV || [ "$OLD_FSTYP" != "$FSTYP" ]; then
+               echo "RECREATING    -- $FSTYP on $TEST_DEV"
+               umount $TEST_DEV 2> /dev/null
+               if ! _test_mkfs >$tmp.err 2>&1
+               then
+                       echo "our local _test_mkfs routine ..."
+                       cat $tmp.err
+                       echo "check: failed to mkfs \$TEST_DEV using specified options"
+                       exit 1
+               fi
+               out=`_mount_or_remount_rw "$MOUNT_OPTIONS" $TEST_DEV $TEST_DIR`
+               if [ $? -ne 1 ]; then
+                       echo $out
+                       exit 1
+               fi
+               _prepare_test_list
+       elif [ "$OLD_MOUNT_OPTIONS" != "$MOUNT_OPTIONS" ]; then
+               umount $TEST_DEV 2> /dev/null
+               out=`_mount_or_remount_rw "$MOUNT_OPTIONS" $TEST_DEV $TEST_DIR`
+               if [ $? -ne 1 ]; then
+                       echo $out
+                       exit 1
+               fi
+       fi
 
-    # Similarly, the result directory needs to replace the tests/
-    # part of the test location.
-    group=`dirname $seq`
-    export RESULT_DIR=`echo $group | sed -e "s;$SRC_DIR;$RESULT_BASE;"`
-    mkdir -p $RESULT_DIR
-    seqres="$RESULT_BASE/$seqnum"
+       init_rc
 
-    echo -n "$seqnum"
+       seq="check"
+       check="$RESULT_BASE/check"
 
-    if $showme
-    then
+       # don't leave old full output behind on a clean run
+       rm -f $check.full
+
+       [ -f $check.time ] || touch $check.time
+
+       # print out our test configuration
+       echo "FSTYP         -- `_full_fstyp_details`"
+       echo "PLATFORM      -- `_full_platform_details`"
+       if [ ! -z "$SCRATCH_DEV" ]; then
+         echo "MKFS_OPTIONS  -- `_scratch_mkfs_options`"
+         echo "MOUNT_OPTIONS -- `_scratch_mount_options`"
+       fi
        echo
-       continue
-    elif [ ! -f $seq ]
-    then
-       echo " - no such test?"
-    else
-       # really going to try and run this one
-       #
-       rm -f $seqres.out.bad
-
-       # check if we really should run it
-       if [ -s $tmp.xlist ]; then
-               if grep $seqnum $tmp.xlist > /dev/null 2>&1 ; then
-                       echo "       [expunged]"
-                       continue
-               fi
+       needwrap=true
+
+       if [ ! -z "$SCRATCH_DEV" ]; then
+         umount $SCRATCH_DEV 2>/dev/null
+         # call the overridden mkfs - make sure the FS is built
+         # the same as we'll create it later.
+
+         if ! _scratch_mkfs $flag >$tmp.err 2>&1
+         then
+             echo "our local _scratch_mkfs routine ..."
+             cat $tmp.err
+             echo "check: failed to mkfs \$SCRATCH_DEV using specified options"
+             exit 1
+         fi
+
+         # call the overridden mount - make sure the FS mounts with
+         # the same options that we'll mount with later.
+         if ! _scratch_mount >$tmp.err 2>&1
+         then
+             echo "our local mount routine ..."
+             cat $tmp.err
+             echo "check: failed to mount \$SCRATCH_DEV using specified options"
+             exit 1
+         fi
        fi
 
-       # slashes now in names, sed barfs on them so use grep
-       lasttime=`grep -w ^$seq check.time | awk '// {print $2}'`
-       if [ "X$lasttime" != X ]; then
-               echo -n " ${lasttime}s ..."
-       else
-               echo -n "       "       # prettier output with timestamps.
-       fi
-       rm -f core $seqres.notrun
+       seqres="$check"
+       _check_test_fs
 
-       start=`_wallclock`
-       $timestamp && echo -n " ["`date "+%T"`"]"
-       [ ! -x $seq ] && chmod u+x $seq # ensure we can run it
-       $LOGGER_PROG "run xfstest $seqnum"
-       ./$seq >$tmp.rawout 2>&1
-       sts=$?
-       $timestamp && _timestamp
-       stop=`_wallclock`
+       for seq in $list
+       do
+           err=false
+
+           # the filename for the test and the name output are different.
+           # we don't include the tests/ directory in the name output.
+           seqnum=`echo $seq | sed -e "s;$SRC_DIR/;;"`
+
+           # Similarly, the result directory needs to replace the tests/
+           # part of the test location.
+           group=`dirname $seq`
+           if $OPTIONS_HAVE_SECTIONS; then
+               export RESULT_DIR=`echo $group | sed -e "s;$SRC_DIR;${RESULT_BASE}/$section;"`
+               seqres="$RESULT_BASE/$section/$seqnum"
+           else
+               export RESULT_DIR=`echo $group | sed -e "s;$SRC_DIR;$RESULT_BASE;"`
+               seqres="$RESULT_BASE/$seqnum"
+           fi
 
-       _fix_malloc <$tmp.rawout >$tmp.out
-       rm -f $tmp.rawout
+           mkdir -p $RESULT_DIR
 
-       if [ -f core ]
-       then
-           echo -n " [dumped core]"
-           mv core $RESULT_BASE/$seqnum.core
-           err=true
-       fi
+           echo -n "$seqnum"
 
-       if [ -f $seqres.notrun ]
-       then
-           $timestamp || echo -n " [not run] "
-           $timestamp && echo " [not run]" && echo -n "        $seqnum -- "
-           cat $seqres.notrun
-           notrun="$notrun $seqnum"
-       else
-           if [ $sts -ne 0 ]
+           if $showme
            then
-               echo -n " [failed, exit status $sts]"
-               err=true
-           fi
-           if [ ! -f $seq.out ]
+               echo
+               continue
+           elif [ ! -f $seq ]
            then
-               echo " - no qualified output"
-               err=true
+               echo " - no such test?"
            else
-               if diff $seq.out $tmp.out >/dev/null 2>&1
+               # really going to try and run this one
+               #
+               rm -f $seqres.out.bad
+
+               # check if we really should run it
+               if [ -s $tmp.xlist ]; then
+                       if grep $seqnum $tmp.xlist > /dev/null 2>&1 ; then
+                               echo "       [expunged]"
+                               continue
+                       fi
+               fi
+
+               # slashes now in names, sed barfs on them so use grep
+               lasttime=`grep -w ^$seqnum $check.time | awk '// {print $2}'`
+               if [ "X$lasttime" != X ]; then
+                       echo -n " ${lasttime}s ..."
+               else
+                       echo -n "       "       # prettier output with timestamps.
+               fi
+               rm -f core $seqres.notrun
+
+               start=`_wallclock`
+               $timestamp && echo -n " ["`date "+%T"`"]"
+               [ ! -x $seq ] && chmod u+x $seq # ensure we can run it
+               $LOGGER_PROG "run xfstest $seqnum"
+               ./$seq >$tmp.rawout 2>&1
+               sts=$?
+               $timestamp && _timestamp
+               stop=`_wallclock`
+
+               _fix_malloc <$tmp.rawout >$tmp.out
+               rm -f $tmp.rawout
+
+               if [ -f core ]
+               then
+                   echo -n " [dumped core]"
+                   mv core $RESULT_BASE/$seqnum.core
+                   err=true
+               fi
+
+               if [ -f $seqres.notrun ]
                then
-                   if $err
+                   $timestamp || echo -n " [not run] "
+                   $timestamp && echo " [not run]" && echo -n "        $seqnum -- "
+                   cat $seqres.notrun
+                   notrun="$notrun $seqnum"
+               else
+                   if [ $sts -ne 0 ]
                    then
-                       :
-                   else
-                       echo "$seqnum `expr $stop - $start`" >>$tmp.time
-                       echo -n " `expr $stop - $start`s"
+                       echo -n " [failed, exit status $sts]"
+                       err=true
                    fi
-                   echo ""
-               else
-                   echo " - output mismatch (see $seqres.out.bad)"
-                   mv $tmp.out $seqres.out.bad
-                   $diff $seq.out $seqres.out.bad | {
-                       if test "$DIFF_LENGTH" -le 0; then
-                               cat
+                   if [ ! -f $seq.out ]
+                   then
+                       echo " - no qualified output"
+                       err=true
+                   else
+
+                       # coreutils 8.16+ changed quote formats in error messages from
+                       # `foo' to 'foo'. Filter old versions to match the new version.
+                       sed -i "s/\`/\'/g" $tmp.out
+                       if diff $seq.out $tmp.out >/dev/null 2>&1
+                       then
+                           if $err
+                           then
+                               :
+                           else
+                               echo "$seqnum `expr $stop - $start`" >>$tmp.time
+                               echo -n " `expr $stop - $start`s"
+                           fi
+                           echo ""
                        else
-                               head -n "$DIFF_LENGTH"
-                       fi; } | \
-                       sed -e 's/^\(.\)/    \1/'
-                   echo "     ..."
-                   echo "     (Run '$diff $seq.out $seqres.out.bad' to see the" \
-                        "entire diff)"
-                   err=true
+                           echo " - output mismatch (see $seqres.out.bad)"
+                           mv $tmp.out $seqres.out.bad
+                           $diff $seq.out $seqres.out.bad | {
+                               if test "$DIFF_LENGTH" -le 0; then
+                                       cat
+                               else
+                                       head -n "$DIFF_LENGTH"
+                                       echo "..."
+                                       echo "(Run '$diff $seq.out $seqres.out.bad'" \
+                                               " to see the entire diff)"
+                               fi; } | \
+                               sed -e 's/^\(.\)/    \1/'
+                           err=true
+                       fi
+                   fi
                fi
+
            fi
-       fi
 
-    fi
+           # come here for each test, except when $showme is true
+           #
+           if $err
+           then
+               bad="$bad $seqnum"
+               n_bad=`expr $n_bad + 1`
+               quick=false
+           fi
+           if [ ! -f $seqres.notrun ]
+           then
+               try="$try $seqnum"
+               n_try=`expr $n_try + 1`
+               _check_test_fs
+           fi
 
-    # come here for each test, except when $showme is true
-    #
-    if $err
-    then
-       bad="$bad $seqnum"
-       n_bad=`expr $n_bad + 1`
-       quick=false
-    fi
-    if [ ! -f $seqres.notrun ]
-    then
-       try="$try $seqnum"
-       n_try=`expr $n_try + 1`
-        _check_test_fs
-    fi
+           seq="after_$seqnum"
+       done
+       _wrapup
+       echo
 
-    seq="after_$seqnum"
+       umount $TEST_DEV 2> /dev/null
+       umount $SCRATCH_DEV 2> /dev/null
 done
 
 interrupt=false
-status=`expr $n_bad`
+status=`expr $sum_bad`
 exit